import logging
import logging.handlers


class FinalLogger(object):

    def __init__(self):
        self.levels = {
            "n": logging.NOTSET,
            "d": logging.DEBUG,
            "i": logging.INFO,
            "w": logging.WARN,
            "e": logging.ERROR,
            "c": logging.CRITICAL}
        self.log_level = "d"
        self.log_file = "final_logger.log"
        self.log_max_byte = 10 * 1024 * 1204
        self.log_backup_count = 5

    def getLogger(self, name=None):
        logger = logging.getLogger(name)
        file_handler = logging.handlers.RotatingFileHandler(
            filename=self.log_file,
            maxBytes=self.log_max_byte,
            backupCount=self.log_backup_count)
        formatter = logging.Formatter(
            '%(asctime)s %(process)d %(levelname)s %(name)s [-] %(message)s')
        file_handler.setFormatter(formatter)
        logger.addHandler(file_handler)
        logger.setLevel(self.levels.get(self.log_level))
        return logger
